
Hi @blah,

Thanks for invite me to this issue. I'll try to explain here my view of the transformation issue. I'm heavily influenced by my experience developing scorejs, so some background first:

As you know, I've been playing with the idea of a score-centric representation that allow music/programmers to define fragments of score, and transformations of it. Those transformations work in a variety of domains like structure (`repeat`, `retrograde`), note modifications (`transpose`), time manipulation (`delay`, `timestretch`) and performance characteristics (`crescendo`). The score fragments and the transformations applied should be expressed in a declarative way.

I wasn't very happy with the first implementation so I continued thinking other alternatives, until I found "Haskell school of music" paper which opened my eyes to another way of representing music I liked a lot. Unfortunately, I couldn't found a way to translate those ideas from Hashkell to Javascript until I read "Lisp as a second language" (although a very important feature, the lazyness, is still not implemented)

A prototype in javascript of those ideas are in the `v4` branch of scorejs repository. While implementing this prototype its clear to me that it was necessary, not only a collection of those transformations, but also a kind of way to extend and _compose_ (in the functional programming meaning of term) those transformations in new ones. I think the prototype solves that in an elegant way. I've created this gist explaining this in detail and any feedback (or collaboration) are welcomed.

For me, it's now more clear the difference between perfomance-data and score-data (and that was the topic of our first issue #1) and I agreed with you there that the domain of MusicJSON was related to performance.

Currently I tend more to think that MusicJSON should focus on performance data, and even remove all the _semantic_ stuff like chords and allow explicitly to include more perfomance-oriented information like pitch expressed in hz. But I'm open and happy to explore and discuss more options.

The main problem to me is: the number of possible transformations seems huge (infinite?) so, where to stop? It's obvious that should include some  like `transpose` and `retrograde` but I have more doubts about `transpose-diationic`.
